[![kofi](https://az743702.vo.msecnd.net/cdn/kofi3.png?v=0)](https://ko-fi.com/cityrobo)

# Modular Workshop

This is a dependency and loader for the revolutionary Modular Workshop system, that allows for modular weapons without the large performance impact that usually accompanies them.

## Benefits of Modular Workshop weapons:
1. Much better performance compared to regular, attachment system based modular weapons.
2. Less clutter in the item spawner.
3. Faster swapping of parts. Build your own personal weapon in no time!
4. Allows anyone to add new skins for weapons. Even vanilla and other modded weapons via the use of the Universal Modular Skin System!
5. Hugely reduced development time for implementers due to the massive reduction of required metadata compared to regular modular weapon mods.

Who said Modular Guns had to be laggy?

## Changelog
v1.1.1 Fixed Phys-Container not being emptied correctly. Fixed some ammo type related vaulting issues.

v1.1.0 Major update bringing Take & Hold randomization! Get a new build every time you get a Modular Workshop gun! Can be disabled in the config file or in game via the Sodalite Mod Panel. ModularPhysicalObject script added: Now everything can be made modular! Magazine extension addon added: Time to make those magazines larger! Also a bunch of bug fixes and other improvements under the hood!

v1.0.3 Important vault behavior change that makes attachment mount order deterministic so that attachments actually reappear on the mounts they were attached on when vaulting. Will not "break" vault files but might mess them up. A necessary evil I am afraid. Also more changes for BreakActionWeapons.

v1.0.2 Fixed some issues related to what is colloquially knowns as a "Unity Moment", something that shouldn't happen but Unity Editor just goes brrrrr. Fixed a bug that would cause red error text to appear with integrated scopes. Added Modular Handguard Extension, Modular Break Action Weapon, Modular Tube Fed Shotgun, WeaponPartSpecificGameObjectToggle and WeaponPartSpecificGameObjectManipulation scripts. Replaced "Also occupies point" field with a list so that a part can occupied more than just one point more.

v1.0.1 Fixed some issues with Modular Stock Extensions related to script execution order.

v1.0.0 Initial Release.